var Enemy = function(hp, damage) {
	var swapDirections = function(self) {
		var dir = GetPersonDirection(GetCurrentPerson());
		if (dir == "east")
			SetPersonDirection(GetCurrentPerson(), "west");
		else SetPersonDirection(GetCurrentPerson(), "east");
		self.dir *= -1;
	};
	return {
		dir: -1,
		grav: undefined,
		create: function(self) {
			SetPersonValue(GetCurrentPerson(), "hp", hp);
			SetPersonValue(GetCurrentPerson(), "damage", damage);
			SetPersonDirection(GetCurrentPerson(), "west");
			self.grav = Gravity(GetCurrentPerson());
			UpdateHooks.add(self.grav);
			//SetPersonScript(GetCurrentPerson(), SCRIPT_ON_ACTIVATE_TOUCH, "TouchPita()");
			IgnoreList.push(GetCurrentPerson());
		},
		
		destroy: function(self) {
			var time = GetTime();
			var dir  = GetPersonValue(GetCurrentPerson(), "dead_dir");
			var amp  = Math.random() * 2 + 1;
			var lin  = 15;
			var rand = (Math.floor(Math.random()*10) + 10) * dir;
			var ss   = GetPersonSpriteset(GetCurrentPerson());
			var sprite = new SpriteImage(ss.filename.substr(11));
			sprite.setDir(GetPersonDirection(GetCurrentPerson()));
			var x = GetPersonX(GetCurrentPerson()) - (ss.base.x2 - ss.base.x1) / 2;
			var y = GetPersonY(GetCurrentPerson()) - (ss.base.y2 - ss.base.y1) / 2;
			var f = function() {
				var dt = (GetTime() - time) / 350;
				var new_y = y + dt * dt * dt + amp * dt * dt - lin * dt;
				sprite.blit(MapToScreenX(0, x + rand * dt), MapToScreenY(0, new_y));
				sprite.update();
				if (new_y > GetScreenHeight()) return true;
			};
			RenderHooks.add(f);
			UpdateHooks.remove(self.grav);
			// ************************************************************************************************************************
			// find method for removing
			// IgnoreList.remove(GetCurrentPerson());
		},
		
		generator: function(self) {
			var x = GetPersonX(GetCurrentPerson());
			var y = GetPersonY(GetCurrentPerson());
			var p = GetObstructingPerson(GetCurrentPerson(), x + self.dir, y);
			var p_top = GetObstructingPerson(GetCurrentPerson(), x + self.dir, y - 1);
			if (p === "Pita") {
				 if (!IsInvulnerable()) {
					TouchPita();
					BecomeInvulnerable();
				}
			} else if (IsPersonObstructed(GetCurrentPerson(), x + self.dir, y)) {
				swapDirections(self);
			} else if (!IsPersonObstructed(GetCurrentPerson(), x + 16 * self.dir, y + 1)) {
				swapDirections(self);
			} else {
				SetPersonX(GetCurrentPerson(), x + self.dir);
				if (p_top === "Pita")
					SetPersonX("Pita", GetPersonX("Pita") + self.dir);
			}
		}
	}
};

var Pushable = function() {
	return {
		create: function(self) {
			SetPersonValue(GetCurrentPerson(), "pushable", true);
			self.grav = Gravity(GetCurrentPerson());
			UpdateHooks.add(self.grav);
		},
		destroy: function(self) {
			UpdateHooks.remove(self.grav);
		}
	};
};

var NPC = function(talk_func, after_talk) {
	var after = after_talk || function() {}; // do nothing
	return {
		talked: false,
		talk: function(self) {
			if (!self.talked) {
				self.talked = true;
				talk_func();
			} else {
				after();
			}
		}
	};
}

var IgnoreList = [];