const INITIAL_VELOCITY = 6;
const MAX_DOWNWARD_VELOCITY = -6;

var Jump = function(gravity) {
	if (gravity.jumpedAt === -1) {
		gravity.jumpedAt = GetTime();
		SetPersonValue(gravity.on, "velocity", INITIAL_VELOCITY);
	}
}

var Gravity = function(name) {
	var VelocityIncrement = function(x, y, v) {
		var sign = (v >= 0) ? 1 : -1;
		var ds = sign * v;
		while (ds > 0) {
			if (!IsPersonObstructed(name, x, y - sign)) {
				SetPersonY(name, y - sign);
				y -= sign;
			} else {
				SetPersonValue(name, "velocity", 0);
				f.jumpedAt = -1;
			}
			ds--;
		}
	};
	
	var f = function() {
		var x  = GetPersonX(name);
		var y  = GetPersonY(name);
		var v  = GetPersonValue(name, "velocity");
		var dt = (GetTime() - f.jumpedAt) / 1000;
		
		if (v > MAX_DOWNWARD_VELOCITY)
			SetPersonValue(name, "velocity", v - .25);
		
		VelocityIncrement(x, y, v);
	};
	f.jumpedAt = -1;
	f.on = name;
	
	return f;
};

var PitaGravity = Gravity("Pita");
	

var DeJump = function(gravity) {
	if (GetPersonValue(gravity.on, "velocity") >= 0) {
		SetPersonValue(gravity.on, "velocity", 0);
	}
};