/*** Functions ***/

Function.prototype.andThen = function(g) {
	var f = this;
	return function() {
		f();g();
	}
}

/*** Arrays ***/


var forEach = function(array, action) {
	for (var i = 0; i < array.length; i++)
		action(array[i]);
}

var map = function(array, action) {
	var result = [];
	forEach(array, function (element) {
		result.push(action(element));
	});
	return result;
}

var reduce = function(array, templateFunction) {
	var s;
	forEach(array, function (element) {
		s += templateFunction(element)
	});
	return s;
}

var filter = function(array, condition) {
  var result = [];
  forEach(array, function (element) {
    if (condition(element))
      result.push(element);
  });
  return result;
}