var Shoot = function() {
	var name  = "bullet_" + Shoot.bulletID;
	var speed = GetPersonDirection("Pita").indexOf("west") != -1 ? -Shoot.bulletSpeed : Shoot.bulletSpeed;
	Shoot.lastShot = GetTime();
	Shoot.bulletID++;
	
	CreatePerson(name, Shoot.spriteset, true);
	SetPersonDirection(name, Shoot.bulletDir);
	SetPersonX(name, GetPersonX("Pita"));
	SetPersonY(name, GetPersonY("Pita"));
	IgnorePersonObstructions(name, true);
	
	// Cool gravity effect. Slows down your fall!
	if (GetPersonValue("Pita", "velocity") < 0)
		SetPersonValue("Pita", "velocity", 0);
	UpdateHooks.add(BulletGenerator(name, speed));
}
Shoot.spriteset = "Bullet.rss";
Shoot.bulletSpeed = 7;
Shoot.bulletID = 0;
Shoot.canPush = false;
Shoot.bulletDir = "default";

var BulletGenerator = function(name, speed) {
	var f = function() {
		if (!IsInPersonList(name)) return true;
		var x = GetPersonX(name);
		var y = GetPersonY(name);
		SetPersonX(name, x + speed);
		if (IsPersonObstructed(name, x, y)) {
			DestroyPerson(name);
			return true;
		}
		var person = GetObstructingPerson(name, x, y);
		if (person != "" && person != "Pita") {
			// animate hurt.
			var dir = speed > 0 ? 1 : -1;
			if (GetPersonValue(person, "pushable") && Shoot.canPush)
				UpdateHooks.add(Knockback(person, dir, 16));
			else if (GetPersonValue(person, "hp") !== "") {
				SetPersonValue(person, "hp", GetPersonValue(person, "hp") - 1);
				if (GetPersonValue(person, "hp") <= 0) {
					SetPersonValue(person, "dead_dir", dir);
					DestroyPerson(person);
					DestroyPerson(name);
					return true;
				} else {
					UpdateHooks.add(Knockback(person, dir, 30));
				}
			}
			DestroyPerson(name);
			return true;
		}
		
		if (MapToScreenX(0, x) < -20 || MapToScreenX(0, x) > GetScreenWidth()) {
			DestroyPerson(name);
			return true;
		}
	};
	return f;
};